import React, {Component} from 'react';
import utils from './utils';
import Store from './store';

function cb(container, name, payload) {
    if (name) {
        container.setState(state => {
            let res = {...state};
            res[name] = payload;
            return res;
        });
    }
    else {
        container.setState(state => {
            return {...state, ...payload};
        });
    }
}

function makeid()
{
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
    for( var i=0; i < 10; i++ )
        text += possible.charAt(Math.floor(Math.random() * possible.length));
    return text;
}

export default function (composer, decomposer, properties, onEnter, mapData) {
  return function wrap(UIComponent) {
    return class extends Component {
      constructor(props) {
        super(props);
        this.id = makeid();
      }

      componentDidMount() {
        composer(cb.bind(null, this), this.id);
        if (onEnter && utils.isFunction(onEnter)) {
            onEnter(this.props);
        }
        const _this = this;
        Object.getOwnPropertyNames(UIComponent.prototype).forEach(function(key) {
          if (!utils.REACT_FUNC.includes(key)) {
            _this[key] = UIComponent.prototype[key].bind(_this.wrapped);
          }
        });
      }

      componentWillUnmount() {
        decomposer(this.id);
      }

      render() {
        const props = {...mapData(Store), ...this.state, ...this.props, ...properties};
        return <UIComponent {...props} ref={(child) => { this.wrapped = child; }}/>
      }
    }
  }
}
